/* Main.ino file generated by New Project wizard
 *
 * Created:   Mon Jan 22 2018
 * Processor: Arduino Uno
 * Compiler:  Arduino AVR (Proteus)
 */
#include <avr/io.h> //standard AVR header
#include <avr/interrupt.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
volatile short data_in[425];

char* find_note(float f){
  if(f>350){
    char* ans = "not in range";
      return ans;
  }
 else if (349.23 < f){
      char* ans = "F4";
      return ans;
  }
  else if(f> 329.63){
    char* ans = "E4";
    return ans;
  }
  else if(f> 311.13){
    char* ans = "D#4/Eb4";
    return ans; 
  }
  else if(f> 293.66){
    char* ans = "D4";
    return ans;
  }
  else if(f> 277.18){
    char* ans = "C#4/Db4";
    return ans;
  }
  else if(f> 261.63){
    char* ans = "C4";
    return ans;
  }
  else if(f> 249.94){
    char* ans = "B3";
    return ans;
  }
  else if(f> 233.08){
    char* ans = "A#3/Bb3";
    return ans;
  }
  else if(f> 220.00){
    char* ans = "A3";
    return ans;
  }
  else if(f> 207.65){
    char* ans = " G#3/Ab";
    return ans;

  }
  else if(f> 196.00){
    char* ans = "G3";
    return ans;
  }
  else if(f> 185.00){
    char* ans = "F#3/Gb3";
    return ans;
  }
  else if(f> 174.61){
    char* ans = "F3";
    return ans;
  }
  else if(f> 164.81){
    char* ans = "E3";
    return ans;
  }
  else if(f> 155.56){
    char* ans = "D#3/Eb3";
    return ans;
  }
  else if(f> 146.83){
    char* ans = "D3";
    return ans;
  }
  else if(f> 138.59){
    char* ans = " C#3/Db3";
    return ans;
  }
  else if(f> 130.81){
    char* ans = "C3";
    return ans;
  }
  else if(f> 123.47){
    char* ans = "B2";
    return ans;
  }
  else if(f> 116.54){
    char* ans = " A#2/Bb2";
    return ans;
  }
  else if(f> 110.00){
    char* ans = "A2";
    return ans;
  }
  else if(f> 103.83){
    char* ans = "G#2/Ab2";
    return ans;
  }
  else if(f> 98.00){
    char* ans = "G2";
    return ans;
  }
  else if(f> 92.50){
    char* ans = "F#2/Gb2";
    return ans;
  }
  else if(f> 87.31){
    char* ans = "F2";
    return ans;
  }
  else if(f> 85){
    char* ans = "E2";
    return ans;
  }
  else{
  char* ans ="not in range";
  return ans;
  }
}

unsigned long auto_correlate(int lag){
   unsigned long res = 0;
   
   for(int i = 0; i < 425 - lag; i++)
      res += data_in[i] * data_in[i + lag];
   return res;
}

int PDA(){
   unsigned long max1 = auto_correlate(0);
   unsigned long pre = max1;
   boolean cond1 = false;
   
   for(int lag = 1; lag < 212; lag++){
      unsigned long current = auto_correlate(lag);
      if(cond1 && current < pre) return lag-1;
      if(current > max1/2 && current > pre) cond1=true;
      else cond1 = false;
      pre = current;
   }
   return 0;
}

void setup()
{ // put your setup code here, to run once:

  // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);
}

void loop()
 { // put your main code here, to run repeatedly:
  delayMicroseconds(242);
  
  long t1 = millis();
    
  for (int i = 0; i < 425; i++)
    data_in[i]=analogRead(A0);
   
  long t2 = millis();

  float sample_dur = (float)(t2-t1)*1000/425;
  
  float period = PDA() *sample_dur;
  
  float frequency = 1000000 / period;

 //  float frequency = (float)9615/period;
   lcd.clear();
  lcd.print(frequency);
   lcd.setCursor(0,1);
   lcd.print(find_note(frequency));
  lcd.setCursor(0,0);
 }
